//+------------------------------------------------------------------+
//|                                                          GT2.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                             http://www.mql4.com/ru/users/rustein |
//+------------------------------------------------------------------+

//-------------------------------------------------------------------+
extern int    Magic          = 212121;
//-------------------------------------------------------------------+
extern int    Slippage       = 5;
//-------------------------------------------------------------------+
extern int    StopLoss       = 5;
//-------------------------------------------------------------------+
extern bool   MoneyMangement = true;
extern double Lots           = 0.01;
extern double MaximumRisk    = 0.5;
//-------------------------------------------------------------------+
extern bool   Trailing       = true;
extern int    TrailingStop   = 5;
extern int    TrailingStep   = 1;
//-------------------------------------------------------------------+
extern string OrderComent    = "GT2";
//+------------------------------------------------------------------+
int cnt = 0;
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|            DO NOT MODIFY ANYTHING BELOW THIS LINE!!!             |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
//---- return orders volume
   if(buys>0) return(buys);
   else       return(-sells);
  }
//+------------------------------------------------------------------+
void start()
  {
   if(MoneyMangement == true)
   Lots=NormalizeDouble(AccountFreeMargin()*MaximumRisk/100/100.0,2);
   else Lots = Lots;
   if(Trailing) TrailPositions();
//---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;
//---- calculate open orders by current symbol
   if(CalculateCurrentOrders(Symbol())==0) CheckForOpen();
  } 
//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
  {
   int res;
//---- go trading only for first tiks of new bar
//   if(Volume[0]>1) return;
//--------------------------------------------------------------------+
//---- buy conditions
     if(Close[1] < Close[2])
     {
      res = OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,Ask-(StopLoss*Point),Ask+(StopLoss*StopLoss*Point),OrderComent,Magic,0,CLR_NONE);
      return;        
     }
//---- sell conditions
     if(Close[1] > Close[2])  
     {
      res = OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,Bid+(StopLoss*Point),Bid-(StopLoss*StopLoss*Point),OrderComent,Magic,0,CLR_NONE);
      return;  
     }
//+------------------------------------------------------------------+
  }
//+------------------------------------------------------------------+
//|-----------------------// Trail positions //----------------------+
//+------------------------------------------------------------------+
void TrailPositions()
{
  int Orders = OrdersTotal();
  for (int i=0; i<Orders; i++)
  {
    if (!(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))) continue;
    if (OrderSymbol() != Symbol()) continue;
    {    
      if (OrderType() == OP_BUY && OrderMagicNumber()==Magic)  
      {
        if (Bid-OrderOpenPrice() > (StopLoss+TrailingStop)*Point) 
        {
          if (OrderStopLoss() < Bid-(TrailingStop+TrailingStep-1)*Point) 
          {
          OrderModify(OrderTicket(),OrderOpenPrice(),Bid-TrailingStop*Point,OrderTakeProfit(),0,CLR_NONE);       
          }
        }
      }   
      if (OrderType() == OP_SELL && OrderMagicNumber()==Magic)  
      {
        if (OrderOpenPrice()-Ask > (StopLoss+TrailingStop)*Point) 
        {
          if (OrderStopLoss() > Ask+(TrailingStop+TrailingStep-1)*Point) 
          {
          OrderModify(OrderTicket(),OrderOpenPrice(),Ask+TrailingStop*Point,OrderTakeProfit(),0,CLR_NONE);         
          }
        }
      }   
    }   
  }  
}
//+------------------------------------------------------------------+
//|---------------------------// END //------------------------------|
//+------------------------------------------------------------------+